
# TODO:
#	- test__core_stat.py fails on 32-bit builds with system libev
#	  investigate/fix that and enable system libev
#
#	- investigate some other failing tests
#	  (now excluded via known_failures-pld.patch)

# Conditional build:
%bcond_without	tests	# do not run tests
%bcond_with	system_libev	# build with system libev (more tests will fail)
%bcond_without	system_c_ares	# build with system c_ares

%define     module  gevent
Summary:	A coroutine-based Python networking library
Name:		python-%{module}
Version:	1.0.2
Release:	1
License:	MIT
Group:		Development/Languages
Source0:	http://pypi.python.org/packages/source/g/gevent/%{module}-%{version}.tar.gz
# Source0-md5:	117f135d57ca7416203fba3720bf71c1
Patch0:		known_failures-pld.patch
URL:		http://www.gevent.org/
%{?with_system_c_ares:BuildRequires:	c-ares-devel >= 1.10.0}
%{?with_system_libev:BuildRequires:	libev-devel >= 4.11}
#BuildRequires:	python-Cython
BuildRequires:	python-devel
%if %{with tests}
BuildRequires:	python-devel-src
BuildRequires:	python-greenlet >= 0.3.2
BuildRequires:	python-test
BuildRequires:	rpmbuild(macros) >= 1.688
%endif
BuildRequires:	rpm-pythonprov
Requires:	python-greenlet >= 0.3.2
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
gevent is a coroutine-based Python networking library.

Features include:

- Fast event loop based on libev.
- Lightweight execution units based on greenlet.
- Familiar API that re-uses concepts from the Python standard library.
- Cooperative sockets with SSL support.
- DNS queries performed through c-ares or a threadpool.
- Ability to use standard library and 3rd party modules written for
  standard blocking sockets

%prep
%setup -q -n %{module}-%{version}
%patch0 -p1

%build
# when Cython-generated files are to be rebuilt
# (BR: python-Cython must be enabled then too)
# ln -s Makefile.ext Makefile

CC="%{__cc}" \
CFLAGS="%{rpmcflags}" \
%{?with_system_libev:LIBEV_EMBED=false} \
%{?with_system_c_ares:CARES_EMBED=false} \
%{__python} setup.py build

%if %{with tests}
cd greentest
PYTHONPATH=.. python testrunner.py --config ../known_failures.py
cd ..
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{?with_system_libev:LIBEV_EMBED=false} \
%{?with_system_c_ares:CARES_EMBED=false} \
%{__python} setup.py install \
    --skip-build \
    --optimize=2 \
    --root=$RPM_BUILD_ROOT

%py_postclean

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE README.rst
%dir %{py_sitedir}/%{module}
%{py_sitedir}/%{module}/*.py[co]
%attr(755,root,root) %{py_sitedir}/%{module}/_semaphore.so
%attr(755,root,root) %{py_sitedir}/%{module}/_util.so
%attr(755,root,root) %{py_sitedir}/%{module}/ares.so
%attr(755,root,root) %{py_sitedir}/%{module}/core.so
%if "%{py_ver}" > "2.4"
%{py_sitedir}/%{module}-%{version}-py%{py_ver}.egg-info
%endif
%changelog
* Tue Jul 14 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-gevent.git;a=log;h=master

* Tue Jul 14 2015 Jacek Konieczny <j.konieczny@eggsoft.pl> e9a76ba
- another network test failing on builders

* Tue Jul 14 2015 Jacek Konieczny <j.konieczny@eggsoft.pl> 5a77c3d
- Version: 1.0.2

* Sat May 30 2015 Elan Ruusamäe <glen@delfi.ee> 2fed4eb
- attempt to convert known failures to new format

* Sat May 30 2015 Elan Ruusamäe <glen@delfi.ee> 4c3c966
- known tests renamed to .py upstream

* Thu Mar 12 2015 Mateusz Korniak <matkor@pld-linux.org> 6c017ba
- 1.0.1-1. No fix for SSL errors introduced by Python 2.7.9.

* Mon Feb 24 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> 140cee9
- fix bcond dependencies

* Sat Feb 22 2014 Jacek Konieczny <jajcus@jajcus.net> 19395fb
- disable system_libev - a test fails

* Sat Feb 22 2014 Jacek Konieczny <jajcus@jajcus.net> 282f7bb
- Build with system libev and c-ares

* Sat Feb 22 2014 Jacek Konieczny <jajcus@jajcus.net> 907aafc
- Ignore two more tests failing on Th builders

* Sat Feb 22 2014 Jacek Konieczny <jajcus@jajcus.net> 73d3206
- local proxy settings should not cause test failures

* Sat Feb 22 2014 Jacek Konieczny <jajcus@jajcus.net> 7c3f7ce
- BR: python-devel-src for tests

* Fri Feb 21 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> 27ee9f0
- R: python-greenlet >= 0.3.2

* Fri Feb 21 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> 35bee9c
- tests: BR: python-greenlet

* Fri Feb 21 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> 31e6d75
- move tests run to %build, when it belongs

* Fri Feb 21 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> 0f612c0
- Add the missing *.so files

* Fri Feb 21 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> 321347f
- BR: python-test when running the tests

* Fri Feb 21 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> 11497ff
- Run tests in %build

* Fri Feb 21 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> 3cc5492
- Version: 1.0

* Fri Jul 27 2012 Elan Ruusamäe <glen@delfi.ee> 78f066e
- missing dir; adapter

* Fri Jul 27 2012 Elan Ruusamäe <glen@delfi.ee> 71c0369
- new

